Draft WorkingPlaneProxy: Difference between revisions

From FreeCAD Documentation
m (Redaction)
(More concise; use of icons and {{Button}}s)
Line 21: Line 21:
==How to use== <!--T:3-->
==How to use== <!--T:3-->
# Make sure the [[Draft SelectPlane|Working Plane]] is set as you want.
# Make sure the [[Draft SelectPlane|Working Plane]] is set as you want.
# Go to the menu {{MenuCommand|Draft → Utilities → [[Image:Draft SetWorkingPlaneProxy.png|16px]] [[Draft SetWorkingPlaneProxy|Create WP Proxy]]}}.
# Then go to the menu {{MenuCommand|Draft → Utilities → [[Image:Draft SetWorkingPlaneProxy.png|16px]] [[Draft SetWorkingPlaneProxy|Create WP Proxy]]}}.

The working plane stored in the Proxy object can be restored by double-clicking the object in the tree view, or by selecting the Proxy object and using the {{Button|[[Image:Draft SelectPlane.svg|16px]] [[Draft SelectPlane]]}}.


Notes:
Notes:
* The position of the camera is stored in the Proxy object upon creation. This position can be updated anytime by right-clicking the Proxy object in the tree view, and selecting "Write camera position".
* The working plane stored in the Proxy object can be restored by double-clicking the object in the tree view, or by selecting the Proxy object and using the {{Button|[[Image:Draft SelectPlane.svg|16px]] [[Draft SelectPlane]]}} button.
* The visibility state of all objects in the current document is also stored in the Proxy object upon creation. This state can be updated anytime by right-clicking the Proxy object in the tree view, and selecting "Write objects state".
* The position of the camera is stored in the Proxy object upon creation. This position can be updated anytime by right-clicking the Proxy object in the tree view, and selecting {{Button|[[Image:Draft SelectPlane.svg|16px]] Write camera position}}.
* The visibility state of all objects is also stored in the Proxy object upon creation. This state can be updated anytime by right-clicking the Proxy object in the tree view, and selecting {{Button|[[Image:Draft SelectPlane.svg|16px]] Write objects state}}.
* The size and appearance of the proxy object can be set in the view properties.
* Plane proxies can be manipulated, moved and rotated, like any other FreeCAD object, so that they are in the desired position.
* Plane proxies can be moved and rotated like any other object so that they are in the desired position. Their visual appearance can also be defined in their properties.


==Properties== <!--T:7-->
==Properties== <!--T:7-->

Revision as of 01:40, 21 November 2018

Draft SetWorkingPlaneProxy

Menu location
Draft → Utilities → Create WP Proxy
Workbenches
Draft, Arch
Default shortcut
None
Introduced in version
-
See also
Draft SelectPlane

Description

This command will place a Plane Proxy object aligned to the current Working Plane.

This proxy object can be used like a face to quickly change the working plane using the Draft SelectPlane tool. The camera position and visibility of the objects in the 3D view can be saved in the proxy object, and restored at anytime when the Draft SelectPlane tool is used.

How to use

  1. Make sure the Working Plane is set as you want.
  2. Then go to the menu Draft → Utilities → File:Draft SetWorkingPlaneProxy.png Create WP Proxy.

Notes:

  • The working plane stored in the Proxy object can be restored by double-clicking the object in the tree view, or by selecting the Proxy object and using the Draft SelectPlane button.
  • The position of the camera is stored in the Proxy object upon creation. This position can be updated anytime by right-clicking the Proxy object in the tree view, and selecting Write camera position.
  • The visibility state of all objects is also stored in the Proxy object upon creation. This state can be updated anytime by right-clicking the Proxy object in the tree view, and selecting Write objects state.
  • Plane proxies can be moved and rotated like any other object so that they are in the desired position. Their visual appearance can also be defined in their properties.

Properties

Data

  • DataPlacement: specifies the position of the proxy object and the corresponding working plane.
    • DataPosition: specifies the coordinates of the proxy object.
    • DataAngle: specifies the rotation angle of the proxy object.
    • DataAxis: specifies the axis to use for the rotation angle.

View

  • ViewDisplay Size: specifies the size of the proxy object in the 3D view. If the proxy object is created in the tree view but no element is visible, increase this value until it is visible.
  • ViewArrow Size: specifies the size of the arrows indicating the three axes of the plane proxy.
  • ViewRestore View: if it is true the camera position will be restored to the saved position when using the proxy with Draft SelectPlane or by double-clicking on it.
  • ViewRestore State: if it is true the visibility state of all objects will be restored to the saved state when using the proxy with Draft SelectPlane or by double-clicking on it. If new objects are added to the document after the state was stored in the Proxy object, the visibility of these new objects will be unchanged.

Scripting

See also: Draft API and FreeCAD Scripting Basics.

Working plane proxy objects can be used in macros and from the Python console by using the following function:

WPProxy = makeWorkingPlaneProxy(placement)
  • Creates a WPProxy object from the given placement which is a FreeCAD.Placement.
    • A placement is defined by a base point, given by its FreeCAD.Vector, and a FreeCAD.Rotation.

The size of the Plane Proxy can be changed by overwriting its ViewObject.DisplaySize and ViewObject.ArrowSize attributes, with units in millimeters.

The Plane Proxy has a "Face" object as its Shape attribute. This face can be used to set the current working plane by calling its alignToFace() method.

Example:

import FreeCAD, FreeCADGui, Draft

currentWP = FreeCAD.DraftWorkingPlane
place = currentWP.getPlacement()

WPProxy = Draft.makeWorkingPlaneProxy(place)
WPProxy.ViewObject.DisplaySize = 3000
WPProxy.ViewObject.ArrowSize = 200

YAxis = FreeCAD.Vector(0, 1, 0)
point2 = FreeCAD.Vector(3000, 0, 0)
place2 = FreeCAD.Placement(point2, FreeCAD.Rotation(YAxis, 90))

WPProxy2 = Draft.makeWorkingPlaneProxy(place2)
WPProxy2.ViewObject.DisplaySize = 3000
WPProxy2.ViewObject.ArrowSize = 200

Axis = FreeCAD.Vector(1, 1, 1)
point3 = FreeCAD.Vector(-3000, 3000, 0)
place3 = FreeCAD.Placement(point3, FreeCAD.Rotation(Axis, 90))

WPProxy3 = Draft.makeWorkingPlaneProxy(place3)
WPProxy3.ViewObject.DisplaySize = 3000
WPProxy3.ViewObject.ArrowSize = 200
FreeCAD.ActiveDocument.recompute()

currentWP.alignToFace(WPProxy3.Shape)
FreeCADGui.Snapper.setGrid()